﻿
init python:
    from copy import copy
    renpy.music.register_channel("sound1", "sfx1", False)
    class gem_drop_gem:
        def __init__(self, image):
            self.image = image
            self.speed = 0
            self.x = 0
            self.y = -100
            self.direction = 1
            self.zoom = 1
        def tick(self):
            self.speed += 1
            self.y += self.speed

    class gem_drop_class:
        def __init__(self, all):
            self.all = all
            self.variation = 1
            self.gems = []
            self.x = 0
            self.y = 0
            self.points = 0

        def ticker(self):
            self.x, self.y = renpy.get_mouse_pos()
            for i in self.gems:
                i.tick()
                if self.y-50 < i.y < self.y+100:
                    if self.x-100 < i.x < self.x+100:
                        self.gems.remove(i)
                        self.points += 1
                        renpy.play("gem_drop/catch.ogg", "sound")
                elif i.y > 1000:
                    self.gems.remove(i)
                    self.points -= 20
                    if self.points < 0:
                        self.points = 0
                        renpy.play("gem_drop/shatter.ogg", "sound1")
            
        def spawn(self):
            gem = copy(renpy.random.choice(self.all))
            gem.x = renpy.random.randint(100, 1720)
            gem.direction = renpy.random.choice([0, 1])
            gem.zoom = renpy.random.randint(4,10)*.1
            self.gems.append(gem)

default gem_1 = gem_drop_gem("gem_1")
default gem_2 = gem_drop_gem("gem_2")
default gem_3 = gem_drop_gem("gem_3")
default gem_4 = gem_drop_gem("gem_4")
default gem_5 = gem_drop_gem("gem_5")
default gem_6 = gem_drop_gem("gem_6")
default gem_7 = gem_drop_gem("gem_7")
default gem_8 = gem_drop_gem("gem_8")
default gem_9 = gem_drop_gem("gem_9")
default gem_drop_handler = gem_drop_class(
    [gem_1, gem_2, gem_3, gem_4, gem_5, gem_6, gem_7, gem_8, gem_9]
    )

screen gem_drop(g = gem_drop_handler):
    hbox:
        spacing 10 offset 20,20
        add "gem_9" at zoom(0.4)
        text str(g.points) align .5,.5
    timer renpy.random.random()*3 repeat True action Function(g.spawn)
    timer .03 repeat True action Function(g.ticker)
    for i in g.gems:
        fixed:
            fit_first True
            xpos i.x ypos i.y xalign .5 anchor .5,.5
            add i.image:
                if i.direction:
                    at rotate(i.y, i.zoom)
                else:
                    at rotate(-i.y, i.zoom)
            # text str(i.x)

    fixed:
        fit_first True
        pos g.x,g.y anchor .5,.5
        add "basket"

transform rotate(r, z):
    rotate r zoom z
transform zoom(z):
    zoom z





label gem_drop_example:
    show bg
    call screen gem_drop

